
add_library(Qt5::QtVirtualKeyboardPinyinPlugin MODULE IMPORTED)

set(_Qt5QtVirtualKeyboardPinyinPlugin_MODULE_DEPENDENCIES "VirtualKeyboard;Gui;Qml;Core")

foreach(_module_dep ${_Qt5QtVirtualKeyboardPinyinPlugin_MODULE_DEPENDENCIES})
    if(NOT Qt5${_module_dep}_FOUND)
        find_package(Qt5${_module_dep}
            1.0.0 ${_Qt5VirtualKeyboard_FIND_VERSION_EXACT}
            ${_Qt5VirtualKeyboard_DEPENDENCIES_FIND_QUIET}
            ${_Qt5VirtualKeyboard_FIND_DEPENDENCIES_REQUIRED}
            PATHS "${CMAKE_CURRENT_LIST_DIR}/.." NO_DEFAULT_PATH
        )
    endif()
endforeach()

_qt5_VirtualKeyboard_process_prl_file(
    "${_qt5VirtualKeyboard_install_prefix}/plugins/virtualkeyboard/libqtvirtualkeyboard_pinyin.prl" RELEASE
    _Qt5QtVirtualKeyboardPinyinPlugin_STATIC_RELEASE_LIB_DEPENDENCIES
    _Qt5QtVirtualKeyboardPinyinPlugin_STATIC_RELEASE_LINK_FLAGS
)


set_property(TARGET Qt5::QtVirtualKeyboardPinyinPlugin PROPERTY INTERFACE_SOURCES
    "${CMAKE_CURRENT_LIST_DIR}/Qt5VirtualKeyboard_QtVirtualKeyboardPinyinPlugin_Import.cpp"
)

_populate_VirtualKeyboard_plugin_properties(QtVirtualKeyboardPinyinPlugin RELEASE "virtualkeyboard/libqtvirtualkeyboard_pinyin.a" FALSE)

list(APPEND Qt5VirtualKeyboard_PLUGINS Qt5::QtVirtualKeyboardPinyinPlugin)
set_property(TARGET Qt5::VirtualKeyboard APPEND PROPERTY QT_ALL_PLUGINS_virtualkeyboard Qt5::QtVirtualKeyboardPinyinPlugin)
# $<GENEX_EVAL:...> wasn't added until CMake 3.12, so put a version guard around it
if(CMAKE_VERSION VERSION_LESS "3.12")
    set(_manual_plugins_genex "$<TARGET_PROPERTY:QT_PLUGINS>")
    set(_plugin_type_genex "$<TARGET_PROPERTY:QT_PLUGINS_virtualkeyboard>")
    set(_no_plugins_genex "$<TARGET_PROPERTY:QT_NO_PLUGINS>")
else()
    set(_manual_plugins_genex "$<GENEX_EVAL:$<TARGET_PROPERTY:QT_PLUGINS>>")
    set(_plugin_type_genex "$<GENEX_EVAL:$<TARGET_PROPERTY:QT_PLUGINS_virtualkeyboard>>")
    set(_no_plugins_genex "$<GENEX_EVAL:$<TARGET_PROPERTY:QT_NO_PLUGINS>>")
endif()
set(_user_specified_genex
    "$<IN_LIST:Qt5::QtVirtualKeyboardPinyinPlugin,${_manual_plugins_genex};${_plugin_type_genex}>"
)
string(CONCAT _plugin_genex
    "$<$<OR:"
        # Add this plugin if it's in the list of manual plugins or plugins for the type
        "${_user_specified_genex},"
        # Add this plugin if the list of plugins for the type is empty, the PLUGIN_EXTENDS
        # is either empty or equal to the module name, and the user hasn't blacklisted it
        "$<AND:"
            "$<STREQUAL:${_plugin_type_genex},>,"
            "$<OR:"
                "$<STREQUAL:$<TARGET_PROPERTY:Qt5::QtVirtualKeyboardPinyinPlugin,QT_PLUGIN_EXTENDS>,Qt5::VirtualKeyboard>,"
                "$<STREQUAL:$<TARGET_PROPERTY:Qt5::QtVirtualKeyboardPinyinPlugin,QT_PLUGIN_EXTENDS>,>"
            ">,"
            "$<NOT:$<IN_LIST:Qt5::QtVirtualKeyboardPinyinPlugin,${_no_plugins_genex}>>"
        ">"
    ">:Qt5::QtVirtualKeyboardPinyinPlugin>"
)
set_property(TARGET Qt5::VirtualKeyboard APPEND PROPERTY INTERFACE_LINK_LIBRARIES
    ${_plugin_genex}
)
set_property(TARGET Qt5::QtVirtualKeyboardPinyinPlugin APPEND PROPERTY INTERFACE_LINK_LIBRARIES
    "Qt5::VirtualKeyboard;Qt5::Gui;Qt5::Qml;Qt5::Core"
)
set_property(TARGET Qt5::QtVirtualKeyboardPinyinPlugin PROPERTY QT_PLUGIN_TYPE "virtualkeyboard")
set_property(TARGET Qt5::QtVirtualKeyboardPinyinPlugin PROPERTY QT_PLUGIN_EXTENDS "")
